/******************* (C) COPYRIGHT 2009~2021 holychip **************************
* File Name          : BUZZ.c
********************************************************************************


*******************************************************************************/
#include "HC89F3541.h"
#include "PWM.h"
#include "BUZZ.h"

bit	BZ_MODE_F = 0;

ux8 T_BZS_COUNT = 0;
ux8 T_BZC_COUNT = 0;
ux8 T_BZT_COUNT = 0;

ux8 T_BZC_TEMP = 0;
ux8 T_BZE_TEMP = 0;
ux8 T_BZD_TEMP = 0;

//===============================================================================
void BUZZER_ON(u8 num, u8 t_on, u8 t_off)
{
	T_BZS_COUNT = 0;
	T_BZT_COUNT = 0;

	T_BZE_TEMP = t_on;
	T_BZD_TEMP = t_off;
	T_BZC_TEMP = num;

	if(T_BZC_TEMP != 0)
	{
		PWM3_On();
	}
	else
	{
		PWM3_Off();
	}
	BZ_MODE_F = 1;
}

//===============================================================================
void BZ_Driver(void)
{
	if(T_BZC_TEMP != 0)
	{
		if(++T_BZS_COUNT  >= T_BZS_DF)
		{
			T_BZS_COUNT = 0;

			if(BZ_MODE_F)
			{
				//ON
				if(++T_BZT_COUNT >= T_BZE_TEMP)
				{
					T_BZT_COUNT = 0;
					BZ_MODE_F = 0;
					T_BZC_TEMP--;
					PWM3_Off();
				}
			}
			else
			{
				//OFF
				if(++T_BZT_COUNT  >= T_BZD_TEMP)
				{
					T_BZT_COUNT = 0;
					if(T_BZC_TEMP > 0)
					{
						BZ_MODE_F = 1;
						PWM3_On()	;
					}
				}
			}
		}
	}
}