/******************* (C) COPYRIGHT 2009~2021 holychip **************************
* File Name          : EEPROM.c
********************************************************************************


*******************************************************************************/
#include "HC89F3541.h"
#include "EEPROM.h"
#include "HolyChip_Level_Touch_Lib_V1.00\HolyChip_Level_Touch_Lib.h"
#include "intrins.h"

//===================================================================================================
void SAVE_DATA(unsigned int fui_Address,unsigned char fuc_Length,unsigned int *fucp_SaveArr)//intEEPROM
{	
	
	ux8 i;
	ux8 Save_Value = 0;
	
	Flash_EraseBlock(fui_Address);
	
	for(i=0;i<fuc_Length;i++)
	{
	  Save_Value = fucp_SaveArr[i]/256;
	  Flash_WriteArr(fui_Address,1,&Save_Value);
      fui_Address++;
	  Save_Value = fucp_SaveArr[i]%256;
	  Flash_WriteArr(fui_Address,1,&Save_Value);
	  fui_Address++;
	}
}

//===================================================================================================
void READ_DATA(unsigned int fui_Address,unsigned char fuc_Length,unsigned int *fuip_Read)//charݴŵint
{
	ux8 Read_Value[1] = {0};
	ux8 H,L,i;
	for(i=0;i<fuc_Length;i++)
	{
	  Flash_ReadArr(fui_Address,1,Read_Value);
	  H = Read_Value[0];
      fui_Address++;
	  Flash_ReadArr(fui_Address,1,Read_Value);
	  L = Read_Value[0];
	  fui_Address++;
	  fuip_Read[i] = (H<<8|L);
	}
}

//===================================================================================================
void SAVE_FLAG(unsigned int fui_Address,bit fuc_Value)
{
	ux8 fuc_Pas;
	fuc_Pas = fuc_Value;
	Flash_EraseBlock(fui_Address);
	FLASH_WriteData(fui_Address,fuc_Pas);
}

bit READ_FLAG(unsigned int fui_Address)
{
	 ux8 fuc_Pas;
	 bit fuc_Value;
	 Flash_ReadArr(fui_Address,1,&fuc_Pas);
	 fuc_Value = fuc_Pas;
	 return fuc_Value;
}

/**
  * @˵  	Լ5msʱ
  * @  	fui_Address ڵһַ
  * @ֵ 
  * @ע		ֻҪһַͿԲ
  */
#pragma disable							//ȷʱжϵµʧ
void Flash_EraseBlock(unsigned int fui_Address)
{
	IAP_CMD = 0xF00F;					//Flash
	IAP_ADDR = fui_Address;				//дַ
	IAP_CMD = 0xD22D;					//ѡʽ 
	IAP_CMD = 0xE11E; 					//IAP_ADDRL&IAP_ADDRHָ0xFFͬʱԶ
}

/**
  * @˵  	дһֽݵFlash
  * @  	fui_Address FLASHַ
  *	@	fucp_SaveDataд
  * @ֵ 
  * @ע		д֮ǰȶԲв
  */
#pragma disable							//ȷʱжϵµʧ
void FLASH_WriteData(unsigned int fui_Address, unsigned char fuc_SaveData)
{
	IAP_DATA = fuc_SaveData;
	IAP_CMD=0xF00F;					//Flash
	IAP_ADDR = fui_Address;
	IAP_CMD=0xB44B;					//ֽڱ
	IAP_CMD=0xE11E;					//һβ
}

/**
  * @˵  	дⳤȵݵFLASH
  * @  	fui_Address FLASHʼַ
  *	@	fuc_Length  дݳ
  *			ȡֵΧ0x00-0xFF
  *	@	*fucp_SaveArrдݴ׵ַ
  * @ֵ 
  * @ע		д֮ǰȶԲв
  */
#pragma disable						//ȷʱжϵµʧ
void Flash_WriteArr(unsigned int fui_Address,unsigned char fuc_Length,unsigned char *fucp_SaveArr)
{
	unsigned char fuc_i = 0;
	for(fuc_i=0;fuc_i<fuc_Length;fuc_i++)
	{
		FLASH_WriteData(fui_Address++,*(fucp_SaveArr++)); 
	}
}

/**
  * @˵  	FLASHȡⳤȵ
  * @  	fui_Address FLASHʼַ
  *	@	fuc_Length ȡݳ
  *			ȡֵΧ0x00-0xFF
  *	@	*fucp_SaveArrȡݴŵ׵ַ
  * @ֵ 
  * @ע		
  */
void Flash_ReadArr(unsigned int fui_Address,unsigned char fuc_Length,unsigned char *fucp_SaveArr)
{
	while(fuc_Length--)
	*(fucp_SaveArr++)=*((unsigned char code *)(fui_Address++));//ȡ
}













